---
# tasks file for posgresql
- name: Install dependencies for PostgreSQL
  apt: name={{ item }} update_cache=true state=latest
  with_items:
      - bash
      - openssl
      - libssl-dev
      - libssl-doc
      - acl
- name: Install PostgreSQL 
  apt: name={{ item }} update_cache=true state=present
  with_items:
      - postgresql
      - postgresql-contrib
      - libpq-dev
      - python3-psycopg2

- name: Ensure the PostgreSQL service is running
  service: name=postgresql state=started enabled=yes
  
- name: Create the database specified in vars
  become_user: postgres
  postgresql_db: 
    state: present
    name: "{{ db_name }}"
  
  
- name: Create db user
  become_user: postgres
  postgresql_user:
    state: present
    name: "{{ db_user }}"
    password: "{{ db_password }}"  

  
- name: Ensure user has access to the new database
  become_user: postgres
  postgresql_user: db={{ db_name }}
      name={{ db_user }}
      password={{ db_password }}
      priv=ALL
      state=present

- name: Ensure user does not have unnecessary permissions
 # become: true
  become_user: postgres
  postgresql_user: name={{ db_user }}
     role_attr_flags=NOSUPERUSER,NOCREATEDB
     state=present

- name: change postgres network binding
  become_user: postgres
  lineinfile:
    path: /etc/postgresql/14/main/postgresql.conf
    regexp: '# listen_addresses'
    line: "listen_addresses = '*'"

- name: change postgres pg hba access
  become_user: postgres
  lineinfile:
    path: /etc/postgresql/14/main/pg_hba.conf
    regexp: 'host  all  all 0.0.0.0/0 md5'
    line: 'host  all  all 0.0.0.0/0 md5'
  notify: restart postgres

